/***************************************************************************
    DbxReader - DBX-handling routines

    author:  Ulrich Krebs
    email :  ukrebs@freenet.de
    credits: Part of this software was taken from
             the libdbx package from David Smith
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream.h>
#include <afx.h>

class CDbxReader
{
private:
	CFile *f;
	BOOL internalFile;
	int dbxType;
	CDWordArray indexes;
	CStringArray subjects;
	CStringArray senders;
	CStringArray senderAddresses;
	CStringArray receivers;
	CStringArray receiverAddresses;
	CTime *receiveDates;
	CTime *sendDates;
	void Init();
	void ReadIndexes();
	void ReadIndex(DWORD pos);
	void ReadInfos();
	CString ReadString(DWORD offset);
	CTime ReadDate(DWORD offset);

public:
	enum
	{
		TYPE_EMAIL=0,
		TYPE_FOLDER=1,
		TYPE_OE4=2,
		TYPE_UNKNOWN=3
	};

	CDbxReader(CFile *f);
	CDbxReader(CString fileName);
	~CDbxReader();
	
	CString GetFileName();
	CTime GetFileDate();
	int GetType();
	int GetItemCount();
	int GetIndex(int i);
	CString GetSender(int msgNumber);
	CString GetSenderAddress(int msgNumber);
	CString GetReceiver(int msgNumber);
	CString GetReceiverAddress(int msgNumber);
	CString GetSubject(int msgNumber);
	CString GetMessage(int msgNumber);
	CTime GetReceiveDate(int msgNumber);
	CTime GetSendDate(int msgNumber);
};

